      PROGRAM CPABCC
      IMPLICIT REAL*8 (A-H,O-Z)
C     AUTHOR:D.A.PAPACONSTANTOPOULOS
C     CPA FOR BINARY ALLOY
C     DERIVATIVES DONE ANALYTICALLY
C  BCC  VERSION
      DIMENSION HMZ(9,9, 300)
      DIMENSION ANUMEL(1000),DUMM(1000),EDUM(1000)
      DIMENSION DUMS1(1000),DUMS2(1000),ANUMS1(1000),ANUMS2(1000)
      DIMENSION QQ(300,3),GR(9,9),GI(9,9)
      DIMENSION WEIGHT( 300),ITIME(5),H(9,9),PAR(44)
      DIMENSION XR(50,9,9),XI(50,9,9),YR(50,9,9),YI(50,9,9),GS(30,300)
      COMMON/JOEL/  TOTVOL,E,EPS,EAS,EAP,EBS,EBP,CB,
     1EAD,EAF,EBD,EBF,NS
      COMMON/DEL/DELSR,DELSI,DELPR,DELPI,DELDR,DELDI,DELFR,DELFI
      COMMON/BLOC1/HMZ,    QQ,WEIGHT,XR,XI,YR,YI,GS,RES,H,PAR,
     1GR,GI,ANUMEL,ANUMS1,ANUMS2,DUMS1,DUMS2,DUMM,EDUM
      DIMENSION  RES(1000,21)
      OPEN(20,FILE='cpain',STATUS='OLD')
      OPEN(25,FILE='cpados',STATUS='UNKNOWN')
      OPEN(30,FILE='cpaout',STATUS='UNKNOWN') 
      CALL MAIN
      STOP
      END
      SUBROUTINE BZONE(N,  NUM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION HMZ(9,9,300),H(9,9),      WEIGHT(300),PAR(44)
      DIMENSION XR(50,9,9),XI(50,9,9),YR(50,9,9),YI(50,9,9),GS(30,300)
      DIMENSION ANUMEL(1000),DUMM(1000),EDUM(1000)
      DIMENSION DUMS1(1000),DUMS2(1000),ANUMS1(1000),ANUMS2(1000)
      COMMON/BLOC1/HMZ,    Q ,WEIGHT,XR,XI,YR,YI,GS,RES,H,PAR,
     1GR,GI,ANUMEL,ANUMS1,ANUMS2,DUMS1,DUMS2,DUMM,EDUM
      DIMENSION Q( 300,3),RES(1000,21),GR(9,9),GI(9,9)
C    ONLY      BCC
      NUM= 0
      IM= 2*N + 1
      NN= 2*N
      FNN = FLOAT(NN)
      DO 10  J=1,IM
      DO 10  I=1,J
      DO 10  K=1,I
                      IT=I+J-1
      IF(IM.LT.IT)                GO TO 10
   66 CONTINUE
      NUM= NUM + 1
      Q(NUM,1)=FLOAT(I-1)/FNN
      Q(NUM,2)= FLOAT(J-1)/FNN
      Q(NUM,3)= FLOAT(K-1)/FNN
   10 CONTINUE
      write(30,100) NUM
 100  FORMAT (1X,"Number of k-points=",I5)
      RETURN
      END
      SUBROUTINE CLSS(N,M,      IA,      IB,NMAT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ANUMEL(1000),DUMM(1000),EDUM(1000)
      DIMENSION DUMS1(1000),DUMS2(1000),ANUMS1(1000),ANUMS2(1000)
      COMMON/BLOC1/HMZ,    QQ,WEIGHT,    AR,AI,BR,BI,GS,RES,H,PAR,
     1GR,GI,ANUMEL,ANUMS1,ANUMS2,DUMS1,DUMS2,DUMM,EDUM
      DIMENSION HMZ(9,9,300),H(9,9),PAR(44),QQ(300,3),WEIGHT(300)
      DIMENSION AR(50,9,9),AI(50,9,9),BR(50,9,9),BI(50,9,9),X(50),T(50)
      DIMENSION L(50),SR1(50),SI1(50),SR2(50),SI2(50),VR(50),VI(50)
      DIMENSION HR(50),HI(50),RES(1000,21)
      DIMENSION GS(30,300),GR(9,9),GI(9,9)
      DIMENSION XD1(50),XD2(50),XD3(50),XD4(50),XD5(50),XD6(50),XD7(50)
      ID=1
      IF(N.GT.IA.OR.N.GT.IB.OR.N.LE.0.OR.M.LE.0) GO TO 17
      DO 11 I=1,N
      IM1=I-1
      DO 110 II=1,NMAT
      TT=AR(II,I,I)**2+AI(II,I,I)**2
      T(II)=SQRT(TT)
  110 CONTINUE
      IF(I.EQ.N) GO TO 130
      DO 109 II=1,NMAT
  109 L(II)=I
      IP1=I+1
      DO 1 J=IP1,N
      DO 111 II=1,NMAT
      XX=AR(II,J,I)**2+AI(II,J,I)**2
      X(II)=SQRT(XX)
      IF(X(II).LE.T(II)) GO TO 111
      T(II)=X(II)
      L(II)=J
  111 CONTINUE
    1 CONTINUE
      DO 112 II=1,NMAT
      IF(T(II).EQ.0.0) GO TO 15
      IF(T(II).LT.1.0E-15) PRINT 80
  112 CONTINUE
   80 FORMAT('  SYSTEM NEAR SINGULAR --- CALCULATION CONTINUING')
      DO 113 II=1,NMAT
      LL=L(II)
      IF(LL.EQ.I) GO TO 4
      DO 2 J=1,N
      TEMPR=AR(II,I,J)
      TEMPI=AI(II,I,J)
      AR(II,I,J)=AR(II,LL,J)
      AI(II,I,J)=AI(II,LL,J)
      AR(II,LL,J)=TEMPR
      AI(II,LL,J)=TEMPI
    2 CONTINUE
      DO 3 J=1,M
      TEMPR=BR(II,I,J)
      TEMPI=BI(II,I,J)
      BR(II,I,J)=BR(II,LL,J)
      BI(II,I,J)=BI(II,LL,J)
      BR(II,LL,J)=TEMPR
      BI(II,LL,J)=TEMPI
    3 CONTINUE
    4 CONTINUE
  113 CONTINUE
  130 CONTINUE
      DO 114 II=1,NMAT
      SR1(II)=AR(II,I,I)**2+AI(II,I,I)**2
  114 CONTINUE
      DO 115 II=1,NMAT
      VR(II)=AR(II,I,I)/SR1(II)
      VI(II)=AI(II,I,I)/SR1(II)
  115 CONTINUE
      IF(I.EQ.N) GO TO 9
      DO 8 J=IP1,N
      DO 116 II=1,NMAT
      SR1(II)=0.0
      SI1(II)=0.0
      SR2(II)=0.0
      SI2(II)=0.0
  116 CONTINUE
      IF(IM1.EQ.0) GO TO 6
      DO 5 K=1,IM1
      DO 5 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,I,K)*AR(II,K,J)-AI(II,I,K)*AI(II,K,J)
      SI1(II)=SI1(II)+AR(II,I,K)*AI(II,K,J)+AR(II,K,J)*AI(II,I,K)
    5 CONTINUE
    6 CONTINUE
      DO 117 II=1,NMAT
      HR(II)=AR(II,I,J)-SR1(II)
      HI(II)=AI(II,I,J)-SI1(II)
  117 CONTINUE
      DO 118 II=1,NMAT
      AR(II,I,J)=HR(II)*VR(II)+HI(II)*VI(II)
      AI(II,I,J)=HI(II)*VR(II)-HR(II)*VI(II)
  118 CONTINUE
      DO 7 K=1,I
      DO 7 II=1,NMAT
      SR2(II)=SR2(II)+AR(II,J,K)*AR(II,K,IP1)-AI(II,J,K)*AI(II,K,IP1)
      SI2(II)=SI2(II)+AR(II,J,K)*AI(II,K,IP1)+AI(II,J,K)*AR(II,K,IP1)
    7 CONTINUE
      DO 119 II=1,NMAT
      AR(II,J,IP1) = AR(II,J,IP1)-SR2(II)
      AI(II,J,IP1) = AI(II,J,IP1)-SI2(II)
  119 CONTINUE
    8 CONTINUE
    9 CONTINUE
      DO 120 II=1,NMAT
      IF(T(II).EQ.0.0) GO TO 15
  120 CONTINUE
      DO 11 J=1,M
      DO 121 II=1,NMAT
      SR1(II)=0.0
  121 SI1(II)=0.0
      IF(IM1.EQ.0) GO TO 21
      DO 10 K=1,IM1
      DO 10 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,I,K)*BR(II,K,J)-AI(II,I,K)*BI(II,K,J)
      SI1(II)=SI1(II)+AI(II,I,K)*BR(II,K,J)+AR(II,I,K)*BI(II,K,J)
   10 CONTINUE
   21 CONTINUE
      DO 122 II=1,NMAT
      HR(II)=BR(II,I,J)-SR1(II)
      HI(II)=BI(II,I,J)-SI1(II)
  122 CONTINUE
      DO 123 II=1,NMAT
      BR(II,I,J)=HR(II)*VR(II)+HI(II)*VI(II)
      BI(II,I,J)=HI(II)*VR(II)-HR(II)*VI(II)
  123 CONTINUE
   11 CONTINUE
      IF(N.EQ.1) RETURN
      NM1=N-1
      DO 13 I=1,M
      DO 13 J=1,NM1
      NMJ=N-J
      DO 124 II=1,NMAT
      SR1(II)=0.0
  124 SI1(II)=0.0
      NMJP1=NMJ+1
      DO 12 K=NMJP1,N
      DO 12 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,NMJ,K)*BR(II,K,I)-AI(II,NMJ,K)*BI(II,K,I)
      SI1(II)=SI1(II)+AR(II,NMJ,K)*BI(II,K,I)+AI(II,NMJ,K)*BR(II,K,I)
   12 CONTINUE
      DO 125 II=1,NMAT
      BR(II,NMJ,I)=BR(II,NMJ,I)-SR1(II)
      BI(II,NMJ,I)=BI(II,NMJ,I)-SI1(II)
  125 CONTINUE
   13 CONTINUE
      RETURN
   15 ID=2
   17 PRINT 85
   85 FORMAT(' DIMENSIONING PROBLEM IN CLSS')
      RETURN
      END
      REAL*8 FUNCTION INTEP   (XX,X,F,J1,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(1),F(1)
      FX=0.
      ISTART=J1-N+N/2+1
      J2=ISTART+N-1
      DO 10 J=ISTART,J2
      P=F(J)
      DO 5 I=ISTART,J2
      IF (I.EQ.J) GO TO 5
      P=P*(XX-X(I))/(X(J)-X(I))
    5 CONTINUE
   10 FX=FX+P
      INTEP=FX
      RETURN
      END
      SUBROUTINE MAIN
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/BLOC1/HMZ,    QQ,WEIGHT,XR,XI,YR,YI,GS,RES,H,UPARM,
     1GR,GI,ANUMEL,ANUMS1,ANUMS2,DUMS1,DUMS2,DUMM,EDUM
      COMMON/JOEL/ TOTVOL,E,EPS,EAS,EAP,EBS,EBP,CB,
     1EAD,EAF,EBD,EBF,NS
      COMMON/DEL/DELSR,DELSI,DELPR,DELPI,DELDR,DELDI,DELFR,DELFI
      DIMENSION GS(30,300)
      DIMENSION WEIGHT( 300)
      DIMENSION QQ(300,3)
      DIMENSION H(9,9),UPARM(44),UPAR(44)
      DIMENSION A(20)
      DIMENSION GR(9,9),GI(9,9),SIGR(9),SIGI(9)
      DIMENSION HMZ(9,9, 300)
      DIMENSION RES(1000,21)
      DIMENSION XR(50,9,9),XI(50,9,9),YR(50,9,9),YI(50,9,9)
      DIMENSION ANUMEL(1000),DUMM(1000),EDUM(1000)
      DIMENSION DUMS1(1000),DUMS2(1000),ANUMS1(1000),ANUMS2(1000)
      DIMENSION DENSFL(6)
      REAL*8 INTEP
      REAL*8 NUELEC
      DIMENSION INAM(3),INA(3),INB(3)
      DATA INB /2HDD,2HP3,2H8 /
      DATA INAM/2HDD,2HP3,2H5 /
 1001 FORMAT(F13.10)
C1001 FORMAT(8F10.4)
 1002 FORMAT(I5,3F10.5)
 1003 FORMAT(6D15.5)
 1004 FORMAT(5F10.4/4F10.4/4F10.4)
 1006 FORMAT(10X,F15.8,I10)
 2002 FORMAT(20A4)
 9000 FORMAT(1H1)
      ICOUNT=0
C     CB1 is different from CB to differentiate between disorder and
C     averaging of parameters.
      CB1=0.5 
      SHIFT=0.000
      PI= 3.1415926536
      PP= 1./PI
      NUMIT=25
C     WRITE(1,9541)
C9541  FORMAT(1X,"ENTER INPUT FILE")
      READ(20,2002)(A(I),I=1,20)
      WRITE(30,2002)(A(I),I=1,20)
      READ(20,1000)NPARM,NDIM,NINI,NFIN,NUELEC,CONV,SHIFT
 1000 FORMAT(4I5,3F10.5)
      WRITE(30,1000)NPARM,NDIM,NINI,NFIN,NUELEC,CONV,SHIFT
      DO 8600  J=1,NPARM
      READ(20,1040)UPARM(J),NNP
      WRITE(30,1006)UPARM(J),NNP
 1040 FORMAT(F13.10,4X,I3)
      IF(NNP.EQ.J) GO TO 8600
      WRITE(30,1045)
 1045 FORMAT(//10X,42H PARAMETER CARDS OUT OF ORDER --- STOPPING)
      STOP
 8600 CONTINUE
      EBS=UPARM(1)
      EBP=UPARM(2)
      EBD=UPARM(3)
      EBF=UPARM(4)
      WRITE(30,1007) EBS,EBP,EBD,EBF
1007  FORMAT(1X,'FIRST ATOM PARAMS',4F10.5)
1008  FORMAT(1X,'SECOND ATOM DIAG. PARAMS',4F10.5)
      DO 8601 J=1,NPARM
      READ(20,1040) UPAR(J),NNP
      WRITE(30,1006)UPAR(J),NNP
      IF (NNP.EQ.J) GO TO 8601
      WRITE(30,1045)
      STOP
8601  CONTINUE
C  SHIFT APPLIED FOR FERROMAGNETIC CASE
      UPAR(1)=UPAR(1)+SHIFT
      EAS=UPAR(1)
      UPAR(2)=UPAR(2)+SHIFT
      EAP=UPAR(2)
      UPAR(3)=UPAR(3)+SHIFT
      EAD=UPAR(3)
      UPAR(4)=UPAR(4)+SHIFT
      EAF=UPAR(4)
      WRITE(30,1008) EAS,EAP,EAD,EAF
      NCHK=0
C     CB=CONCENTRATION OF THE 2ND ATOM
      READ(20,1004)CB,EMIN,EMAX,DELE,EPIV,SAGSR1,SAGSI1,SAGPR1,SAGPI1,
     1SAGDR1,SAGDI1,SAGFR1,SAGFI1
      CB1=CB 
      WRITE(30,9000)
      WRITE(30,1004)
     $         CB,EMIN,EMAX,DELE,EPIV,SAGSR1,SAGSI1,SAGPR1,SAGPI1,
     1SAGDR1,SAGDI1,SAGFR1,SAGFI1
      DO 8602 J=1,NPARM
      UPARM(J)=(1.0-CB1)*UPARM(J)+CB1*UPAR(J)
      WRITE(30,1006) UPARM(J),J
8602  CONTINUE
      READ(20,8700)EPS
      CLOSE(20)
      WRITE(30,8710) EPS
 8710 FORMAT(//,15X,' EPS= ',F15.6,//)
      WRITE(30,8711) CONV
 8711 FORMAT(//,15X,' CONV ',F15.6,//)
 8700 FORMAT(F15.6)
C     CALL TIME(1,272)
C     CALL BZONE(NINI,   NUMINI,JSZ1)
      CALL BZONE(NINI,   NUMINI)
C     CALL TIME(1,274)
      MF2= 2*NINI
      MF21=MF2+1
      WRITE(30,8500)NINI,NUMINI
 8500 FORMAT (//,20X,'MESH= ',I5,10X,I7,' POINTS',//)
C     CALL TIME(2,279)
      CALL WTFID(NINI,MF21)
C     CALL TIME(2,281)
      NS= NUMINI
      N50= NS/50 + 1
      M50= 50*(N50 - 1)
      DO 8580  I=1,NS
      XK1=QQ(I,1)
      XK2=QQ(I,2)
      XK3=QQ(I,3)
C     CALL MATS(XK1,XK2,XK3,H,UPARM,  NDIM)
      CALL MATS(XK1,XK2,XK3,NDIM)
      DO 8575  LL=1,NDIM
      DO 8570  J=1,NDIM
      HMZ(J,LL,I)=H(J,LL)
 8570 CONTINUE
 8575 CONTINUE
 8580 CONTINUE
      MPIV=0
      ISS1= 1
 1111 IF(NCHK.EQ.2)GOTO 1234
      SAGSR=SAGSR1
      SAGSI=SAGSI1
      SAGPR=SAGPR1
      SAGPI=SAGPI1
      SAGDR=SAGDR1
      SAGDI=SAGDI1
      SAGFR=SAGFR1
      SAGFI=SAGFI1
      IF(NCHK.EQ.0)NMODE=1
      IF(NCHK.EQ.1)NMODE=2
      IF(NCHK.EQ.1)EPIV= EPIV - DELE
      E=EPIV
      DO 9999  IXYZ=ISS1,1000
C     IF (MCHK.EQ.1) GO TO 996
C     IF (IXYZ.NE.1.OR.IXYZ.NE.MPIV) GO TO 995
C     IF (IXYZ.GT.6) STOP 20
 996  SIGSR=SAGSR
      SIGSI=SAGSI
      SIGPR=SAGPR
      SIGPI=SAGPI
      SIGDR=SAGDR
      SIGDI=SAGDI
      SIGFR=SAGFR
      SIGFI=SAGFI
 995  CONTINUE
      SIGR (1)=SIGSR
      SIGI(1)=SIGSI
      SIGR(2)=SIGPR
      SIGI(2)=SIGPI
      SIGR(3)=SIGPR
      SIGR(4)=SIGPR
      SIGR(5)=SIGDR
      SIGR(6)=SIGDR
      SIGR(7)=SIGDR
      SIGR(8)=SIGFR
      SIGI(3)=SIGPI
      SIGI(4)=SIGPI
      SIGI(5)=SIGDI
      SIGI(6)=SIGDI
      SIGI(7)=SIGDI
      SIGI(8)=SIGFI
      SIGR(9)=SIGFR
      SIGI(9)=SIGFI
      DO 999 N=1,NUMIT
      WRITE(30,1210) N,SIGSR,SIGSI,SIGPR,SIGPI,SIGDR,SIGDI,SIGFR,SIGFI
1210  FORMAT(I5,8F10.5)
      MCHK=0
      GGSSR=0.0
      GGSSI=0.0
      GGSPR=0.0
      GGPSR=0.0
      GGSPI=0.0
      GGPSI=0.0
      GGPPR=0.0
      GGPPI=0.0
      GGDDR=0.0
      GGDDI=0.0
      GGDFR=0.0
      GGDFI=0.0
      GGFDR=0.0
      GGFDI=0.0
      GGFFR=0.0
      GGFFI=0.0
      GGSDR=0.0
      GGDSR=0.0
      GGSDI=0.0
      GGDSI=0.0
      GGSFR=0.0
      GGFSR=0.0
      GGSFI=0.0
      GGFSI=0.0
      GGPDR=0.0
      GGDPR=0.0
      GGPDI=0.0
      GGDPI=0.0
      GGPFR=0.0
      GGFPR=0.0
      GGPFI=0.0
      GGFPI=0.0
      DO 2020 M=1,9
      DO 2020  L=1,9
      GR(L,M)= 0.0
      GI(L,M)= 0.0
 2020 CONTINUE
C     N50=NS/50+1
C     M50=50*(N50-1)
      DO 820  I1=1,N50
      J50= (I1-1)*50
      I50= 50
      I1111=I1*50
      IF(I1111.GT.NS) I50= NS - M50
      IF( I50.LE.0) GO TO 820
      DO 2222  M=1,9
      DO 2000  L=1,9
      DO 830  I2=1,I50
      I= J50 + I2
      XR(I2,L,M)=  -HMZ(L,M,I)
      XI(I2,L,M)=0.0
      YR(I2,L,M)= 0.0
      YI(I2,L,M)= 0.0
  830 CONTINUE
 2000 CONTINUE
 2222 CONTINUE
      DO 2003 L=1,9
      DO 831 I2=1,I50
      I=J50+I2
      XR(I2,L,L)=E-HMZ(L,L,I)
C   VALUE OF EPS REDUCED FOR S AND P
C     IF (L.LT.5) EPS=0.00001
C     IF (L.GE.5) EPS=0.02
      XI(I2,L,L)=EPS
      YR(I2,L,L)=1.0
      YI(I2,L,L)=0.0
  831 CONTINUE
 2003 CONTINUE
      DO 835  I4=1,9
      DO 832 I2=1,I50
      XR(I2,I4,I4)= XR(I2,I4,I4) - SIGR(I4)
      XI(I2,I4,I4)= XI(I2,I4,I4) - SIGI(I4)
  832 CONTINUE
  835 CONTINUE
C     WRITE(30,1212)
1212  FORMAT(1X,'ENTERING CLSS 9')
C     WRITE(30,2212) I50
2212  FORMAT(2X,'I50=',I5)
      CALL CLSS(9,9,9,9,I50)
C     WRITE(30,1213)
1213  FORMAT(1X,'EXITING CLSS 9')
      DO 99  I2=1,I50
C     WRITE (6,7844)
C     WRITE(30,8844) I2,I50,J50
 7844 FORMAT (1X,'Y-MATRIX')
 8844 FORMAT (1X,'I2,I50,J50 ',3I5)
      I3=I2+J50
C     WRITE (6,7846)  QQ(I3,1),QQ(I3,2),QQ(I3,3),E
C     WRITE (9)       QQ(I3,1),QQ(I3,2),QQ(I3,3),E
 7846 FORMAT (1X,4F10.5)
C     WRITE (6,7845) ((YR(I2,L,M),M=1,8),L=1,8)
 7845 FORMAT (1X,8E14.6)
C     WRITE (9)      ((YR(I2,L,M),M=1,8),L=1,8)
 7847 FORMAT (8F10.6)
C     WRITE (6,7844)
C     WRITE (6,7846)  QQ(I3,1),QQ(I3,2),QQ(I3,3),E
C     WRITE (9)       QQ(I3,1),QQ(I3,2),QQ(I3,3),E
C     WRITE (6,7845) ((YI(I2,L,M),M=1,8),L=1,8)
C     WRITE (9)      ((YI(I2,L,M),M=1,8),L=1,8)
      I= J50 + I2
      GS(1,I)=YR(I2,1,1)
      GS(2,I)=YI(I2,1,1)
      GS(3,I)=(YR(I2,2,2)+YR(I2,3,3)+YR(I2,4,4))/3.0
      GS(4,I)=(YI(I2,2,2)+YI(I2,3,3)+YI(I2,4,4))/3.0
      GS(5,I)=(YR(I2,5,5)+YR(I2,6,6)+YR(I2,7,7))/3.0
      GS(6,I)=(YI(I2,5,5)+YI(I2,6,6)+YI(I2,7,7))/3.0
      GS(7,I)=(YR(I2,8,8)+YR(I2,9,9))/2.0
      GS(8,I)=(YI(I2,8,8)+YI(I2,9,9))/2.0
      G1= YR(I2,1,1)**2 - YI(I2,1,1)**2
      G2= 2.0*YR(I2,1,1)*YI(I2,1,1)
      G3= YR(I2,2,2)*YR(I2,2,2) - YI(I2,2,2)*YI(I2,2,2)
      F3= YR(I2,5,5)*YR(I2,5,5) - YI(I2,5,5)*YI(I2,5,5)
      G4= 2.0*YR(I2,2,2)*YI(I2,2,2)
      F4= 2.0*YR(I2,5,5)*YI(I2,5,5)
      G5= YR(I2,1,2)*YR(I2,2,1) - YI(I2,1,2)*YI(I2,2,1)
      F5= YR(I2,5,8)*YR(I2,8,5) - YI(I2,5,8)*YI(I2,8,5)
      G6= YR(I2,1,2)*YI(I2,2,1) + YR(I2,2,1)*YI(I2,1,2)
      F6= YR(I2,5,8)*YI(I2,8,5) + YR(I2,8,5)*YI(I2,5,8)
      G7= YR(I2,1,3)*YR(I2,3,1) - YI(I2,1,3)*YI(I2,3,1)
      F7= YR(I2,5,9)*YR(I2,9,5) - YI(I2,5,9)*YI(I2,9,5)
      G8= YR(I2,1,3)*YI(I2,3,1) + YR(I2,3,1)*YI(I2,1,3)
      F8= YR(I2,5,9)*YI(I2,9,5) + YR(I2,9,5)*YI(I2,5,9)
      G9= YR(I2,1,4)*YR(I2,4,1) - YI(I2,1,4)*YI(I2,4,1)
      F9= YR(I2,6,8)*YR(I2,8,6) - YI(I2,6,8)*YI(I2,8,6)
      F23=YR(I2,6,9)*YR(I2,9,6) - YI(I2,6,9)*YI(I2,9,6)
      F21=YR(I2,7,8)*YR(I2,8,7) - YI(I2,7,8)*YI(I2,8,7)
      F24=YR(I2,7,9)*YR(I2,9,7) - YI(I2,7,9)*YI(I2,9,7)
      G10=YR(I2,1,4)*YI(I2,4,1) + YR(I2,4,1)*YI(I2,1,4)
      F10=YR(I2,6,8)*YI(I2,8,6) + YR(I2,8,6)*YI(I2,6,8)
      F25=YR(I2,6,9)*YI(I2,9,6) + YR(I2,9,6)*YI(I2,6,9)
      F22=YR(I2,7,8)*YI(I2,8,7) + YR(I2,8,7)*YI(I2,7,8)
      F26=YR(I2,7,9)*YI(I2,9,7) + YR(I2,9,7)*YI(I2,7,9)
      G11=YR(I2,2,3)*YR(I2,3,2) - YI(I2,2,3)*YI(I2,3,2)
      F11=YR(I2,5,6)*YR(I2,6,5) - YI(I2,5,6)*YI(I2,6,5)
      G12=YR(I2,2,3)*YI(I2,3,2) + YR(I2,3,2)*YI(I2,2,3)
      F12=YR(I2,5,6)*YI(I2,6,5) + YR(I2,6,5)*YI(I2,5,6)
      G13=YR(I2,2,4)*YR(I2,4,2) - YI(I2,2,4)*YI(I2,4,2)
      F13=YR(I2,5,7)*YR(I2,7,5) - YI(I2,5,7)*YI(I2,7,5)
      G14=YR(I2,2,4)*YI(I2,4,2) + YR(I2,4,2)*YI(I2,2,4)
      F14=YR(I2,5,7)*YI(I2,7,5) + YR(I2,7,5)*YI(I2,5,7)
      G15=YR(I2,3,4)*YR(I2,4,3) - YI(I2,3,4)*YI(I2,4,3)
      F15=YR(I2,6,7)*YR(I2,7,6) - YI(I2,6,7)*YI(I2,7,6)
      F32=YR(I2,8,9)*YR(I2,9,8) - YI(I2,8,9)*YI(I2,9,8)
      G16=YR(I2,3,4)*YI(I2,4,3) + YR(I2,4,3)*YI(I2,3,4)
      F16=YR(I2,6,7)*YI(I2,7,6) + YR(I2,7,6)*YI(I2,6,7)
      F33=YR(I2,8,9)*YI(I2,9,8) + YR(I2,9,8)*YI(I2,8,9)
      G17=YR(I2,3,3)**2 - YI(I2,3,3)**2
      F17=YR(I2,6,6)**2 - YI(I2,6,6)**2
      G18=2.0*YR(I2,3,3)*YI(I2,3,3)
      F18=2.0*YR(I2,6,6)*YI(I2,6,6)
      G19=YR(I2,4,4)**2 - YI(I2,4,4)**2
      F19=YR(I2,7,7)**2 - YI(I2,7,7)**2
      F28=YR(I2,8,8)**2 - YI(I2,8,8)**2
      F29=YR(I2,9,9)**2 - YI(I2,9,9)**2
      G20=2.0*YR(I2,4,4)*YI(I2,4,4)
      F20=2.0*YR(I2,7,7)*YI(I2,7,7)
      F30=2.0*YR(I2,8,8)*YI(I2,8,8)
      F31=2.0*YR(I2,9,9)*YI(I2,9,9)
 122  FORMAT(1X,'F30,F31,F33',3F10.5)
      F34=YR(I2,1,5)*YR(I2,5,1) - YI(I2,1,5)*YI(I2,5,1)
      F35=YR(I2,1,6)*YR(I2,6,1) - YI(I2,1,6)*YI(I2,6,1)
      F36=YR(I2,1,7)*YR(I2,7,1) - YI(I2,1,7)*YI(I2,7,1)
      F37=YR(I2,1,5)*YI(I2,5,1) + YI(I2,1,5)*YR(I2,5,1)
      F38=YR(I2,1,6)*YI(I2,6,1) + YI(I2,1,6)*YR(I2,6,1)
      F39=YR(I2,1,7)*YI(I2,7,1) + YI(I2,1,7)*YR(I2,7,1)
 123  FORMAT(1X,'F37,F38,F39',3F10.5)
      F40=YR(I2,1,8)*YR(I2,8,1) - YI(I2,1,8)*YI(I2,8,1)
      F41=YR(I2,1,9)*YR(I2,9,1) - YI(I2,1,9)*YI(I2,9,1)
      F42=YR(I2,1,8)*YI(I2,8,1) + YI(I2,1,8)*YR(I2,8,1)
      F43=YR(I2,1,9)*YI(I2,9,1) + YI(I2,1,9)*YR(I2,9,1)
      F44=YR(I2,2,5)*YR(I2,5,2) - YI(I2,2,5)*YI(I2,5,2)
      F45=YR(I2,3,5)*YR(I2,5,3) - YI(I2,3,5)*YI(I2,5,3)
      F46=YR(I2,4,5)*YR(I2,5,4) - YI(I2,4,5)*YI(I2,5,4)
      F47=YR(I2,2,6)*YR(I2,6,2) - YI(I2,2,6)*YI(I2,6,2)
      F48=YR(I2,3,6)*YR(I2,6,3) - YI(I2,3,6)*YI(I2,6,3)
      F49=YR(I2,4,6)*YR(I2,6,4) - YI(I2,4,6)*YI(I2,6,4)
      F50=YR(I2,2,7)*YR(I2,7,2) - YI(I2,2,7)*YI(I2,7,2)
      F51=YR(I2,3,7)*YR(I2,7,3) - YI(I2,3,7)*YI(I2,7,3)
      F52=YR(I2,4,7)*YR(I2,7,4) - YI(I2,4,7)*YI(I2,7,4)
      F53=YR(I2,2,5)*YI(I2,5,2) + YI(I2,2,5)*YR(I2,5,2)
      F54=YR(I2,3,5)*YI(I2,5,3) + YI(I2,3,5)*YR(I2,5,3)
      F55=YR(I2,4,5)*YI(I2,5,4) + YI(I2,4,5)*YR(I2,5,4)
      F56=YR(I2,2,6)*YI(I2,6,2) + YI(I2,2,6)*YR(I2,6,2)
      F57=YR(I2,3,6)*YI(I2,6,3) + YI(I2,3,6)*YR(I2,6,3)
      F58=YR(I2,4,6)*YI(I2,6,4) + YI(I2,4,6)*YR(I2,6,4)
      F59=YR(I2,2,7)*YI(I2,7,2) + YI(I2,2,7)*YR(I2,7,2)
      F60=YR(I2,3,7)*YI(I2,7,3) + YI(I2,3,7)*YR(I2,7,3)
      F61=YR(I2,4,7)*YI(I2,7,4) + YI(I2,4,7)*YR(I2,7,4)
      F62=YR(I2,2,8)*YR(I2,8,2) - YI(I2,2,8)*YI(I2,8,2)
      F63=YR(I2,3,8)*YR(I2,8,3) - YI(I2,3,8)*YI(I2,8,3)
      F64=YR(I2,4,8)*YR(I2,8,4) - YI(I2,4,8)*YI(I2,8,4)
      F65=YR(I2,2,9)*YR(I2,9,2) - YI(I2,2,9)*YI(I2,9,2)
      F66=YR(I2,3,9)*YR(I2,9,3) - YI(I2,3,9)*YI(I2,9,3)
      F67=YR(I2,4,9)*YR(I2,9,4) - YI(I2,4,9)*YI(I2,9,4)
      F68=YR(I2,2,8)*YI(I2,8,2) + YI(I2,2,8)*YR(I2,8,2)
      F69=YR(I2,3,8)*YI(I2,8,3) + YI(I2,3,8)*YR(I2,8,3)
      F70=YR(I2,4,8)*YI(I2,8,4) + YI(I2,4,8)*YR(I2,8,4)
      F71=YR(I2,2,9)*YI(I2,9,2) + YI(I2,2,9)*YR(I2,9,2)
      F72=YR(I2,3,9)*YI(I2,9,3) + YI(I2,3,9)*YR(I2,9,3)
      F73=YR(I2,4,9)*YI(I2,9,4) + YI(I2,4,9)*YR(I2,9,4)
      GS(9,I)=G1
      GS(10,I)=G2
      GS(11,I)=G5+G7+G9
      GS(12,I)=G6+G8+G10
      GS(13,I)=(G3+G17+G19)/3.0+(G11+G13+G15)*0.666666
      GS(14,I)=(G4+G18+G20)/3.0+(G12+G14+G16)*0.666666
      GS(15,I)=(F3+F17+F19)/3.0+(F11+F13+F15)*0.666666
      GS(16,I)=(F4+F18+F20)/3.0+(F12+F14+F16)*0.6666666
      GS(17,I)=(F5+F7+F9+F23+F21+F24)/3.0
      GS(18,I)=(F6+F8+F10+F25+F22+F26)/3.0
      GS(19,I)=(F5+F9+F21+F7+F23+F24)/2.0
      GS(20,I)=(F6+F10+F22+F8+F25+F26)/2.0
      GS(21,I)=(F28+F29)/2.0+F32
      GS(22,I)=(F30+F31)/2.0+F33
      GS(23,I)= F34+F35+F36
      GS(24,I)= F37+F38+F39
      GS(25,I)= F40+F41
      GS(26,I)= F42+F43
      GS(27,I)=(F44+F45+F46+F47+F48+F49+F50+F51+F52)/3.0
      GS(28,I)=(F53+F54+F55+F56+F57+F58+F59+F60+F61)/3.0
      GS(29,I)=(F62+F63+F64+F65+F66+F67)/3.0
      GS(30,I)=(F68+F69+F70+F71+F72+F73)/3.0
   99 CONTINUE
  820 CONTINUE
      DO 1230 I=1,NS
      GR(1,1)=GR(1,1)+GS(1,I)*WEIGHT(I)
      GI(1,1)=GI(1,1)+GS(2,I)*WEIGHT(I)
      GR(2,2)=GR(2,2)+GS(3,I)*WEIGHT(I)
      GI(2,2)=GI(2,2)+GS(4,I)*WEIGHT(I)
      GR(5,5)=GR(5,5)+GS(5,I)*WEIGHT(I)
      GI(5,5)=GI(5,5)+GS(6,I)*WEIGHT(I)
      GR(8,8)=GR(8,8)+GS(7,I)*WEIGHT(I)
      GI(8,8)=GI(8,8)+GS(8,I)*WEIGHT(I)
      GGSSR=GGSSR+GS(9,I)*WEIGHT(I)
      GGSSI=GGSSI+GS(10,I)*WEIGHT(I)
      GGSPR=GGSPR+GS(11,I)*WEIGHT(I)
      GGSPI=GGSPI+GS(12,I)*WEIGHT(I)
      GGPPR=GGPPR+GS(13,I)*WEIGHT(I)
      GGPPI=GGPPI+GS(14,I)*WEIGHT(I)
      GGDDR=GGDDR+GS(15,I)*WEIGHT(I)
      GGDDI=GGDDI+GS(16,I)*WEIGHT(I)
      GGDFR=GGDFR+GS(17,I)*WEIGHT(I)
      GGDFI=GGDFI+GS(18,I)*WEIGHT(I)
      GGFDR=GGFDR+GS(19,I)*WEIGHT(I)
      GGFDI=GGFDI+GS(20,I)*WEIGHT(I)
      GGFFR=GGFFR+GS(21,I)*WEIGHT(I)
      GGFFI=GGFFI+GS(22,I)*WEIGHT(I)
      GGSDR=GGSDR+GS(23,I)*WEIGHT(I)
      GGSDI=GGSDI+GS(24,I)*WEIGHT(I)
      GGSFR=GGSFR+GS(25,I)*WEIGHT(I)
      GGSFI=GGSFI+GS(26,I)*WEIGHT(I)
      GGPDR=GGPDR+GS(27,I)*WEIGHT(I)
      GGPDI=GGPDI+GS(28,I)*WEIGHT(I)
      GGPFR=GGPFR+GS(29,I)*WEIGHT(I)
      GGPFI=GGPFI+GS(30,I)*WEIGHT(I)
 1230 CONTINUE
      GR(1,1)= GR(1,1)/TOTVOL
      GI(1,1)= GI(1,1)/TOTVOL
      GR(2,2)= GR(2,2)/TOTVOL
      GI(2,2)= GI(2,2)/TOTVOL
      GR(5,5)=GR(5,5)/TOTVOL
      GI(5,5)=GI(5,5)/TOTVOL
      GR(8,8)=GR(8,8)/TOTVOL
      GI(8,8)=GI(8,8)/TOTVOL
      GGSSR= GGSSR/TOTVOL
      GGSSI= GGSSI/TOTVOL
      GGSPR= GGSPR/TOTVOL
      GGSPI= GGSPI/TOTVOL
      GGPPR= GGPPR/TOTVOL
      GGPPI= GGPPI/TOTVOL
      GGPSR=GGSPR/3.0
      GGPSI=GGSPI/3.0
      GGDDR= GGDDR/TOTVOL
      GGDDI= GGDDI/TOTVOL
      GGDFR= GGDFR/TOTVOL
      GGDFI= GGDFI/TOTVOL
      GGFDR= GGFDR/TOTVOL
      GGFDI= GGFDI/TOTVOL
      GGFFR= GGFFR/TOTVOL
      GGFFI= GGFFI/TOTVOL
      GGSDR= GGSDR/TOTVOL
      GGDSR= GGSDR/3.0
      GGSDI= GGSDI/TOTVOL
      GGDSI= GGSDI/3.0
      GGSFR= GGSFR/TOTVOL
      GGFSR= GGSFR/2.0
      GGSFI= GGSFI/TOTVOL
      GGFSI= GGSFI/2.0
      GGPDR= GGPDR/TOTVOL
      GGDPR= GGPDR
      GGPDI= GGPDI/TOTVOL
      GGDPI= GGPDI
      GGPFR= GGPFR/TOTVOL
      GGFPR= GGPFR*1.5
      GGPFI= GGPFI/TOTVOL
      GGFPI= GGPFI*1.5
      XR(1,1,1)=GGSSR*(SIGR(1)**2-SIGI(1)**2)+GGSSI*SIGI(1)*(EAS+EBS-2.0
     1*SIGR(1))-GGSSR*SIGR(1)*(EAS+EBS)+GGSSR*EAS*EBS+GR(1,1)*(2.0*SIGR(
     11)-EAS-EBS)-2.0*SIGI(1)*GI(1,1)+1.0
      XI(1,1,1)=GGSSI*(SIGR(1)**2-SIGI(1)**2)+GGSSR*SIGI(1)*(2.0*SIGR(1)
     1-EAS-EBS)-GGSSI*SIGR(1)*(EAS+EBS)+GGSSI*EAS*EBS+GI(1,1)*(2.0*SIGR(
     11)-EAS-EBS)+2.0*SIGI(1)*GR(1,1)
      XR(1,1,2)=GGSPR*(SIGR(1)**2-SIGI(1)**2)+GGSPI*SIGI(1)*(EAS+EBS-2.0
     1*SIGR(1))-GGSPR*SIGR(1)*(EAS+EBS)+GGSPR*EAS*EBS
      XI(1,1,2)=GGSPI*(SIGR(1)**2-SIGI(1)**2)+GGSPR*SIGI(1)*(2.0*SIGR(1)
     1-EAS-EBS)-GGSPI*SIGR(1)*(EAS+EBS)+GGSPI*EAS*EBS
      XR(1,1,3)=GGSDR*(SIGR(1)**2-SIGI(1)**2)+GGSDI*SIGI(1)*(EAS+EBS-2.0
     1*SIGR(1))-GGSDR*SIGR(1)*(EAS+EBS)+GGSDR*EAS*EBS
      XI(1,1,3)=GGSDI*(SIGR(1)**2-SIGI(1)**2)+GGSDR*SIGI(1)*(2.0*SIGR(1)
     1-EAS-EBS)-GGSDI*SIGR(1)*(EAS+EBS)+GGSDI*EAS*EBS
      XR(1,1,4)=GGSFR*(SIGR(1)**2-SIGI(1)**2)+GGSFI*SIGI(1)*(EAS+EBS-2.0
     1*SIGR(1))-GGSFR*SIGR(1)*(EAS+EBS)+GGSFR*EAS*EBS
      XI(1,1,4)=GGSFI*(SIGR(1)**2-SIGI(1)**2)+GGSFR*SIGI(1)*(2.0*SIGR(1)
     1-EAS-EBS)-GGSFI*SIGR(1)*(EAS+EBS)+GGSFI*EAS*EBS
      XR(1,2,1)=GGPSR*(SIGR(2)**2-SIGI(2)**2)+GGPSI*SIGI(2)*(EAP+EBP-2.0
     1*SIGR(2))-GGPSR*SIGR(2)*(EAP+EBP)+GGPSR*EAP*EBP
      XI(1,2,1)=GGPSI*(SIGR(2)**2-SIGI(2)**2)+GGPSR*SIGI(2)*(2.0*SIGR(2)
     1-EAP-EBP)-GGPSI*SIGR(2)*(EAP+EBP)+GGPSI*EAP*EBP
      XR(1,2,2)=GGPPR*(SIGR(2)**2-SIGI(2)**2)+GGPPI*SIGI(2)*(EAP+EBP-2.0
     1*SIGR(2))-GGPPR*SIGR(2)*(EAP+EBP)+GGPPR*EAP*EBP+GR(2,2)*(2.0*SIGR
     2(2)-EAP-EBP)-2.0*SIGI(2)*GI(2,2)+1.0
      XI(1,2,2)=GGPPI*(SIGR(2)**2-SIGI(2)**2)+GGPPR*SIGI(2)*(2.0*SIGR(2)
     1-EAP-EBP)-GGPPI*SIGR(2)*(EAP+EBP)+GGPPI*EAP*EBP+GI(2,2)*(2.0*SIGR
     2(2)-EAP-EBP)+2.0*SIGI(2)*GR(2,2)
      XR(1,2,3)=GGPDR*(SIGR(2)**2-SIGI(2)**2)+GGPDI*SIGI(2)*(EAP+EBP-2.0
     1*SIGR(2))-GGPDR*SIGR(2)*(EAP+EBP)+GGPDR*EAP*EBP
      XI(1,2,3)=GGPDI*(SIGR(2)**2-SIGI(2)**2)+GGPDR*SIGI(2)*(2.0*SIGR(2)
     1-EAP-EBP)-GGPDI*SIGR(2)*(EAP+EBP)+GGPDI*EAP*EBP
      XR(1,2,4)=GGPFR*(SIGR(2)**2-SIGI(2)**2)+GGPFI*SIGI(2)*(EAP+EBP-2.0
     1*SIGR(2))-GGPFR*SIGR(2)*(EAP+EBP)+GGPFR*EAP*EBP
      XI(1,2,4)=GGPFI*(SIGR(2)**2-SIGI(2)**2)+GGPFR*SIGI(2)*(2.0*SIGR(2)
     1-EAP-EBP)-GGPFI*SIGR(2)*(EAP+EBP)+GGPFI*EAP*EBP
      XR(1,3,1)=GGDSR*(SIGR(5)**2-SIGI(5)**2)+GGDSI*SIGI(5)*(EAD+EBD-2.0
     1*SIGR(5))-GGDSR*SIGR(5)*(EAD+EBD)+GGDSR*EAD*EBD
      XI(1,3,1)=GGDSI*(SIGR(5)**2-SIGI(5)**2)+GGDSR*SIGI(5)*(2.0*SIGR(5)
     1-EAD-EBD)-GGDSI*SIGR(5)*(EAD+EBD)+GGDSI*EAD*EBD
      XR(1,3,2)=GGDPR*(SIGR(5)**2-SIGI(5)**2)+GGDPI*SIGI(5)*(EAD+EBD-2.0
     1*SIGR(5))-GGDPR*SIGR(5)*(EAD+EBD)+GGDPR*EAD*EBD
      XI(1,3,2)=GGDPI*(SIGR(5)**2-SIGI(5)**2)+GGDPR*SIGI(5)*(2.0*SIGR(5)
     1-EAD-EBD)-GGDPI*SIGR(5)*(EAD+EBD)+GGDPI*EAD*EBD
      XR(1,3,3)=GGDDR*(SIGR(5)**2-SIGI(5)**2)+GGDDI*SIGI(5)*(EAD+EBD-2.0
     1*SIGR(5))-GGDDR*SIGR(5)*(EAD+EBD)+GGDDR*EAD*EBD+GR(5,5)*(2.0*SIGR(
     15)-EAD-EBD)-2.0*SIGI(5)*GI(5,5)+1.0
      XI(1,3,3)=GGDDI*(SIGR(5)**2-SIGI(5)**2)+GGDDR*SIGI(5)*(2.0*SIGR(5)
     1-EAD-EBD)-GGDDI*SIGR(5)*(EAD+EBD)+GGDDI*EAD*EBD+GI(5,5)*(2.0*SIGR(
     15)-EAD-EBD)+2.0*SIGI(5)*GR(5,5)
      XR(1,3,4)=GGDFR*(SIGR(5)**2-SIGI(5)**2)+GGDFI*SIGI(5)*(EAD+EBD-2.0
     1*SIGR(5))-GGDFR*SIGR(5)*(EAD+EBD)+GGDFR*EAD*EBD
      XI(1,3,4)=GGDFI*(SIGR(5)**2-SIGI(5)**2)+GGDFR*SIGI(5)*(2.0*SIGR(5)
     1-EAD-EBD)-GGDFI*SIGR(5)*(EAD+EBD)+GGDFI*EAD*EBD
      XR(1,4,1)=GGFSR*(SIGR(8)**2-SIGI(8)**2)+GGFSI*SIGI(8)*(EAF+EBF-2.0
     1*SIGR(8))-GGFSR*SIGR(8)*(EAF+EBF)+GGFSR*EAF*EBF
      XI(1,4,1)=GGFSI*(SIGR(8)**2-SIGI(8)**2)+GGFSR*SIGI(8)*(2.0*SIGR(8)
     1-EAF-EBF)-GGFSI*SIGR(8)*(EAF+EBF)+GGFSI*EAF*EBF
      XR(1,4,2)=GGFPR*(SIGR(8)**2-SIGI(8)**2)+GGFPI*SIGI(8)*(EAF+EBF-2.0
     1*SIGR(8))-GGFPR*SIGR(8)*(EAF+EBF)+GGFPR*EAF*EBF
      XI(1,4,2)=GGFPI*(SIGR(8)**2-SIGI(8)**2)+GGFPR*SIGI(8)*(2.0*SIGR(8)
     1-EAF-EBF)-GGFPI*SIGR(8)*(EAF+EBF)+GGFPI*EAF*EBF
      XR(1,4,3)=GGFDR*(SIGR(8)**2-SIGI(8)**2)+GGFDI*SIGI(8)*(EAF+EBF-2.0
     1*SIGR(8))-GGFDR*SIGR(8)*(EAF+EBF)+GGFDR*EAF*EBF
      XI(1,4,3)=GGFDI*(SIGR(8)**2-SIGI(8)**2)+GGFDR*SIGI(8)*(2.0*SIGR(8)
     1-EAF-EBF)-GGFDI*SIGR(8)*(EAF+EBF)+GGFDI*EAF*EBF
      XR(1,4,4)=GGFFR*(SIGR(8)**2-SIGI(8)**2)+GGFFI*SIGI(8)*(EAF+EBF-2.0
     1*SIGR(8))-GGFFR*SIGR(8)*(EAF+EBF)+GGFFR*EAF*EBF+GR(8,8)*(2.0*SIGR
     2(8)-EAF-EBF)-2.0*SIGI(8)*GI(8,8)+1.0
      XI(1,4,4)=GGFFI*(SIGR(8)**2-SIGI(8)**2)+GGFFR*SIGI(8)*(2.0*SIGR(8)
     1-EAF-EBF)-GGFFI*SIGR(8)*(EAF+EBF)+GGFFI*EAF*EBF+GI(8,8)*(2.0*SIGR
     2(8)-EAF-EBF)+2.0*SIGI(8)*GR(8,8)
      SIGSR=SIGR(1)
      SIGSI=SIGI(1)
      SIGPR=SIGR(2)
      SIGPI=SIGI(2)
      SIGDR=SIGR(5)
      SIGDI=SIGI(5)
      SIGFR=SIGR(8)
      SIGFI=SIGI(8)
      DELSR1=GR(1,1)*SIGSR**2-GR(1,1)*SIGSI**2-2.0*GI(1,1)*SIGSR*SIGSI
      DELSR2=SIGSR-EAS*GR(1,1)*SIGSR+EAS*GI(1,1)*SIGSI-EBS*GR(1,1)*SIGSR
      DELSR3=EBS*GI(1,1)*SIGSI-CB*EAS+CB*EBS-EBS+EAS*EBS*GR(1,1)
      YR(1,1,1)=DELSR1+DELSR2+DELSR3
      YR(1,1,1)=-YR(1,1,1)
      DELSI1=GI(1,1)*SIGSR**2-GI(1,1)*SIGSI**2+2.0*GR(1,1)*SIGSR*SIGSI
      DELSI2=SIGSI-EAS*GR(1,1)*SIGSI-EAS*GI(1,1)*SIGSR-EBS*GR(1,1)*SIGSI
      DELSI3=-EBS*GI(1,1)*SIGSR+EAS*EBS*GI(1,1)
      YI(1,1,1)=DELSI1+DELSI2+DELSI3
      YI(1,1,1)=-YI(1,1,1)
      DELPR1=GR(2,2)*SIGPR**2-GR(2,2)*SIGPI**2-2.0*GI(2,2)*SIGPR*SIGPI
      DELPR2=SIGPR-EAP*GR(2,2)*SIGPR+EAP*GI(2,2)*SIGPI-EBP*GR(2,2)*SIGPR
      DELPR3=EBP*GI(2,2)*SIGPI-CB*EAP+CB*EBP-EBP+EAP*EBP*GR(2,2)
      YR(1,2,1)=DELPR1+DELPR2+DELPR3
      YR(1,2,1)=-YR(1,2,1)
      DELPI1=GI(2,2)*SIGPR**2-GI(2,2)*SIGPI**2+2.0*GR(2,2)*SIGPR*SIGPI
      DELPI2=SIGPI-EAP*GR(2,2)*SIGPI-EAP*GI(2,2)*SIGPR-EBP*GR(2,2)*SIGPI
      DELPI3=-EBP*GI(2,2)*SIGPR+EAP*EBP*GI(2,2)
      YI(1,2,1)=DELPI1+DELPI2+DELPI3
      YI(1,2,1)=-YI(1,2,1)
      DELDR1=GR(5,5)*SIGDR**2-GR(5,5)*SIGDI**2-2.0*GI(5,5)*SIGDR*SIGDI
      DELDR2=SIGDR-EAD*GR(5,5)*SIGDR+EAD*GI(5,5)*SIGDI-EBD*GR(5,5)*SIGDR
      DELDR3=EBD*GI(5,5)*SIGDI-CB*EAD+CB*EBD-EBD+EAD*EBD*GR(5,5)
      YR(1,3,1)=DELDR1+DELDR2+DELDR3
      YR(1,3,1)=-YR(1,3,1)
      DELDI1=GI(5,5)*SIGDR**2-GI(5,5)*SIGDI**2+2.0*GR(5,5)*SIGDR*SIGDI
      DELDI2=SIGDI-EAD*GR(5,5)*SIGDI-EAD*GI(5,5)*SIGDR-EBD*GR(5,5)*SIGDI
      DELDI3=-EBD*GI(5,5)*SIGDR+EAD*EBD*GI(5,5)
      YI(1,3,1)=DELDI1+DELDI2+DELDI3
      YI(1,3,1)=-YI(1,3,1)
      DELFR1=GR(8,8)*SIGFR**2-GR(8,8)*SIGFI**2-2.0*GI(8,8)*SIGFR*SIGFI
      DELFR2=SIGFR-EAF*GR(8,8)*SIGFR+EAF*GI(8,8)*SIGFI-EBF*GR(8,8)*SIGFR
      DELFR3=EBF*GI(8,8)*SIGFI-CB*EAF+CB*EBF-EBF+EAF*EBF*GR(8,8)
      YR(1,4,1)=DELFR1+DELFR2+DELFR3
      YR(1,4,1)=-YR(1,4,1)
      DELFI1=GI(8,8)*SIGFR**2-GI(8,8)*SIGFI**2+2.0*GR(8,8)*SIGFR*SIGFI
      DELFI2=SIGFI-EAF*GR(8,8)*SIGFI-EAF*GI(8,8)*SIGFR-EBF*GR(8,8)*SIGFI
      DELFI3=-EBF*GI(8,8)*SIGFR+EAF*EBF*GI(8,8)
      YI(1,4,1)=DELFI1+DELFI2+DELFI3
      YI(1,4,1)=-YI(1,4,1)
C     WRITE(30,1214)
1214  FORMAT (5X,'ENTERING CLSS 2')
1215  FORMAT (5X,'EXITING  CLSS 2')
      CALL CLSS(4,1,4,4,1)
C     WRITE(30,1215)
      DELSR= YR(1,1,1)
      DELSI= YI(1,1,1)
      DELPR= YR(1,2,1)
      DELPI= YI(1,2,1)
      DELDR= YR(1,3,1)
      DELDI= YI(1,3,1)
      DELFR= YR(1,4,1)
      DELFI= YI(1,4,1)
C     WRITE(30,1515) DELSR,DELSI,DELPR,DELPI
C     WRITE(30,1516) DELDR,DELDI,DELFR,DELFI
1515  FORMAT('DELS ,DELP',4F10.5)
1516  FORMAT('DELD ,DELF',4F10.5)
      IF(ABS(DELDR).LT.CONV.AND.ABS(DELDI).LT.CONV.AND.ABS(DELFR).LT.
     $ CONV.AND.ABS(DELFI).LT.CONV.AND.ABS(DELSR).LT.CONV.AND.ABS(
     1DELSI).LT.CONV.AND.ABS(DELPR).LT.CONV.AND.ABS(DELPI).LT.CONV)
     2 MCHK=1
      SIGSR= DELSR + SIGSR
      SIGSI= DELSI + SIGSI
      SIGPR= DELPR + SIGPR
      SIGPI= DELPI + SIGPI
      SIGDR= DELDR + SIGDR
      SIGDI= DELDI + SIGDI
      SIGFR= DELFR + SIGFR
      SIGFI= DELFI + SIGFI
      SAGSR= SIGSR
      SAGSI= SIGSI
      SAGPR= SIGPR
      SAGPI= SIGPI
      SAGDR= SIGDR
      SAGDI= SIGDI
      SAGFR= SIGFR
      SAGFI= SIGFI
      SIGR(1)= SIGSR
      SIGI(1)= SIGSI
      SIGR(2)= SIGPR
      SIGR(3)= SIGPR
      SIGR(4)= SIGPR
      SIGI(2)= SIGPI
      SIGI(3)= SIGPI
      SIGI(4)= SIGPI
      SIGR(5)= SIGDR
      SIGR(6)= SIGDR
      SIGR(7)= SIGDR
      SIGR(8)= SIGFR
      SIGI(5)= SIGDI
      SIGI(6)= SIGDI
      SIGI(7)= SIGDI
      SIGI(8)= SIGFI
      SIGR(9)=SIGFR
      SIGI(9)=SIGFI
      IF(MCHK.EQ.1)GOTO9991
 999  CONTINUE
      WRITE(30,5004) E
 5004 FORMAT('   SIGMA DIDN T CONVERGE FOR E=',F10.4)
      NCHK=NCHK+1
      GOTO1111
 9991 CONTINUE
      SIGSR=SIGR(1)
      SIGSI=SIGI(1)
      SIGPR=SIGR(2)
      SIGPI=SIGI(2)
      SIGDR=SIGR(5)
      SIGDI=SIGI(5)
      SIGFR=SIGR(8)
      SIGFI=SIGI(8)
C     WRITE(30,1015) N,SIGSR,SIGSI,SIGPR,SIGPI,E
 1015 FORMAT(5X,I5,4F15.8,F10.3)
C     WRITE(30,1016) GR(1,1),GI(1,1),GR(2,2),GI(2,2)
C     WRITE(30,1016) GR(3,3),GI(3,3),GR(4,4),GI(4,4)
C     WRITE(30,1016) GR(5,5),GI(5,5),GR(6,6),GI(6,6)
C     WRITE(30,1016) GR(7,7),GI(7,7),GR(8,8),GI(8,8)
C     WRITE(30,1016) GR(9,9),GI(9,9)
 1016 FORMAT(1X,4F10.5)
      ROSB=-1.0*PP*(GR(1,1)*SIGSI+GI(1,1)*SIGSR-GI(1,1)*EAS)/(EBS-
     1EAS)
      ROPB=-3.0*PP*(GR(2,2)*SIGPI+GI(2,2)*SIGPR-GI(2,2)*EAP)/(EBP-
     1EAP)
      RODB=-3.0*PP*(GR(5,5)*SIGDI+GI(5,5)*SIGDR-GI(5,5)*EAD)/(EBD-
     1EAD)
      ROFB=-2.0*PP*(GR(8,8)*SIGFI+GI(8,8)*SIGFR-GI(8,8)*EAF)/(EBF-
     1EAF)
      ROSA =-1.0*PP*(GR(1,1)*SIGSI+GI(1,1)*SIGSR-GI(1,1)*EBS)/(EAS-
     1EBS)
      ROPA =-3.0*PP*(GR(2,2)*SIGPI+GI(2,2)*SIGPR-GI(2,2)*EBP)/(EAP-
     1EBP)
      RODA =-3.0*PP*(GR(5,5)*SIGDI+GI(5,5)*SIGDR-GI(5,5)*EBD)/(EAD-
     1EBD)
      ROFA =-2.0*PP*(GR(8,8)*SIGFI+GI(8,8)*SIGFR-GI(8,8)*EBF)/(EAF-
     1EBF)
      ROTOT=ROSA +ROPA +ROSB+ROPB+RODA+ROFA+RODB+ROFB
C     ROTOT=-2.0*PP*GI(1,1)-6.0*PP*GI(2,2)-6.0*PP*GI(5,5)-4.0*PP*GI(8,8)
      RES(IXYZ,1)=E
      RES(IXYZ,2)= SIGSR
      RES(IXYZ,3)= SIGSI
      RES(IXYZ,4)= SIGPR
      RES(IXYZ,5)= SIGPI
      RES(IXYZ,6)=SIGDR
      RES(IXYZ,7)=SIGDI
      RES(IXYZ,8)=SIGFR
      RES(IXYZ,9)=SIGFI
      RES(IXYZ,10)= ROSA
      RES(IXYZ,11)= ROPA
      RES(IXYZ,12)= RODA
      RES(IXYZ,13)= ROFA
      RES(IXYZ,14)=ROSB
      RES(IXYZ,15)=ROPB
      RES(IXYZ,16)=RODB
      RES(IXYZ,17)=ROFB
      RES(IXYZ,18)=ROTOT
      WRITE(30,1030)E,SIGSR,SIGSI,SIGPR,SIGPI,SIGDR,SIGDI,SIGFR,SIGFI
      WRITE(30,1030)E,ROSA,ROPA,RODA,ROFA,ROSB,ROPB,RODB,ROFB,ROTOT
 1030 FORMAT ( 1X,F7.3,9F9.5)
C     PUNCH 4002,E,SIGSR,SIGSI,SIGPR,SIGPI
C     PUNCH 4002,ROSSI,ROPSI,ROSH,ROPH,ROTOT
 4002 FORMAT (5E15.8)
      IF(NMODE.EQ.2)GOTO51
      E=E+DELE
      IF(E.LE.EMAX)GOTO9999
      ISS= IXYZ
      ISS1= ISS + 1
      MPIV=ISS1
      NCHK=NCHK+1
      GOTO1111
 51   E=E-DELE
      IF(E.GE.EMIN)GOTO9999
      GOTO1234
 9999 CONTINUE
 1234 CONTINUE
      ITOP= IXYZ
      WRITE(30,3000)
 3000 FORMAT(1H1,///)
      WRITE(30,3010)
 3010 FORMAT(20X,' PRINTING OF --- ENERGY --COMPLEX SIGS  ---- COMPLEX
     $ SIGP'///)
      L= ITOP + 1
      L9= 0
      DO 3020  LL=ISS1,ITOP
      L= L - 1
      L9= L9 + 1
      EDUM(L9)= RES(L,1)
      DUMS1(L9)=(RES(L,10)+RES(L,11)+RES(L,12)+RES(L,13))*2.0
      DUMS2(L9)=(RES(L,14)+RES(L,15)+RES(L,16)+RES(L,17))*2.0
      DUMM(L9)= RES(L,18)*2.0
      WRITE(30,3030)(RES(L,M),M=1,9)
C     PUNCH 4000,(RES(L,M),M=1,5)
 3030 FORMAT( 1X,F7.3,8F9.5)
 4000 FORMAT(5E15.8)
 3020 CONTINUE
      DO 3040  L=1,ISS
      L9= L9 + 1
      EDUM(L9)= RES(L,1)
      DUMS1(L9)=(RES(L,10)+RES(L,11)+RES(L,12)+RES(L,13))*2.0
      DUMS2(L9)=(RES(L,14)+RES(L,15)+RES(L,16)+RES(L,17))*2.0
      DUMM(L9)= RES(L,18)*2.0
      WRITE(30,3030)(RES(L,M),M=1,9)
 3040 CONTINUE
      NUM99= ITOP-1
      CALL SIMP(EDUM,DUMM,ANUMEL,NUM99)
      CALL SIMP(EDUM,DUMS1,ANUMS1,NUM99)
      CALL SIMP(EDUM,DUMS2,ANUMS2,NUM99)
      ANUMEL(1)= 0.0
      ANUMS1(1)= 0.0
      ANUMS2(1)= 0.0
      ANUMEL(ITOP)= ANUMEL(NUM99) + RES(ISS,18)*DELE*2.0
      ANUMS1(ITOP)= ANUMS1(NUM99) +(RES(ISS,10)+RES(ISS,11)+RES(ISS,12)+
     1RES(ISS,13))*DELE*2.0
      ANUMS2(ITOP)= ANUMS2(NUM99) +(RES(ISS,14)+RES(ISS,15)+RES(ISS,16)+
     1RES(ISS,17))*DELE*2.0
      WRITE(30,3000)
      WRITE(30,3050)
 3050 FORMAT(10X,'  S-A,P-A,D1-A,D2-A,S-B,P-B,D1-B,D2-B,TOT-DOS,NUMEL
     1,NUMELA,NUMELB',///)
      L= ITOP + 1
      L9= 0
      DO 3060  LL=ISS1,ITOP
      L= L - 1
      L9= L9 + 1
      RES(L,19)= ANUMEL(L9)
      RES(L,20)=ANUMS1(L9)
      RES(L,21)=ANUMS2(L9)
      WRITE(30,3070)RES(L,1),(RES(L,M),M=10,21),LL
      WRITE(25,3071)RES(L,1),(RES(L,M),M=10,19),LL
c     WRITE(25,3077) (RES(L,M),M=1,9)
 3070 FORMAT(1X,F7.3,12F8.4,I3)
 3071 FORMAT(1X,F7.3,10F8.4,I3)
 3077 FORMAT(F10.4,4E15.6,/4E15.6)
 4010 FORMAT(F6.3,8F9.5)
 3060 CONTINUE
      DO 3080  L=1,ISS
      L9= L9 + 1
      RES(L,19)= ANUMEL(L9)
      RES(L,20)= ANUMS1(L9)
      RES(L,21)= ANUMS2(L9)
      WRITE(30,3070)RES(L,1),(RES(L,M),M=10,21),L
      WRITE(25,3071)RES(L,1),(RES(L,M),M=10,19),L
c     WRITE(25,3077) (RES(L,M),M=1,9)
 3080 CONTINUE
      MCOUNT=0
      DO 4080 L=1,ITOP
      IF(ANUMEL(L).GT.NUELEC) GO TO 178
      GO TO 4080
  178 IF(MCOUNT .NE. 0) GO TO 4080
      MCOUNT=L
 4080 CONTINUE
C     LINEAR     INTEPOLATION OF THE FERMI LEVEL
      MC=MCOUNT
      MCM=MC-1
      S=NUELEC
      EFL=INTEP(S,ANUMEL   ,EDUM(1) ,MCM,2)
      DNORFL=INTEP(S,ANUMEL   ,DUMM(1)  ,MCM,2)/2.0
      WRITE(30,841)
  841 FORMAT(//65X,11H (PER SPIN)  )
      DENSFL(1)=INTEP(S,ANUMEL   ,DUMS1(1),MCM,2)/2.0
C     DENSFL(2)=INTEP(S,ANUMEL   ,DUMP1(1),MCM,2)/2.0
C     DENSFL(3)=INTEP(S,ANUMEL   ,DUMD1(1),MCM,2)/2.0
C     DENSFL(4)=INTEP(S, ANUMEL  ,DUMD2(1),MCM,2)/2.0
      DENSFL(2)=INTEP(S,ANUMEL   ,DUMS2(1) ,MCM,2)/2.0
C     DENSFL(6)=INTEP(S,ANUMEL   ,DUMP2(1) ,MCM,2)/2.0
      WRITE(6,193)
  193 FORMAT(9X,6HENERGY,7X,9HELECTRONS,6X,9HTOTAL DOS,11X,5HATOM1,
     1 14X,5HATOM2  //)
      WRITE(30,839) EFL,NUELEC,DNORFL,(DENSFL(I),I=1,2)
  839  FORMAT(2F10.5   ,3X,7F10.5//)
      RETURN
      END
      SUBROUTINE SIMP(XX,FX,AX,NX)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XX(2),FX(2),AX(2)
      DELX= XX(2) - XX(1)
      AX(1)= 0.0
      DO 10  IX=2,NX,2
      IF(NX-IX)2,3,2
   2  AX(IX)= DELX*(5.0*FX(IX-1)+8.0*FX(IX)-FX(IX+1))/12.0+AX(IX-1)
      AX(IX+1)=DELX*(FX(IX-1)+4.0*FX(IX)+FX(IX+1))/3.0+AX(IX-1)
   10 CONTINUE
      GO TO 4
    3 AX(NX)=DELX*(-FX(NX-2)+8.0*FX(NX-1)+5.0*FX(NX))/12.0+AX(NX-1)
    4 RETURN
      END
      SUBROUTINE WTFID(MESH,IMESH)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ANUMEL(1000),DUMM(1000),EDUM(1000)
      DIMENSION DUMS1(1000),DUMS2(1000),ANUMS1(1000),ANUMS2(1000)
C  BCC  VERSION
      COMMON/BLOC1/HMZ,    QQ,WT,XR,XI,YR,YI,GS,RES,H,PAR,
     1GR,GI,ANUMEL,ANUMS1,ANUMS2,DUMS1,DUMS2,DUMM,EDUM
      COMMON/JOEL/ SWT,E,EPS,EAS,EAP,EBS,EBP,CB,EAD,EAF,EBD,EBF,NS
      COMMON/DEL/DELSR,DELSI,DELPR,DELPI,DELDR,DELDI,DELFR,DELFI
       DIMENSION GR(9,9),GI(9,9)
      DIMENSION XR(50,9,9),XI(50,9,9),YR(50,9,9),YI(50,9,9)
      DIMENSION WT( 300),QQ(300,3),HMZ(9,9,300)
      DIMENSION GS(30,300),RES(1000,21)
      DIMENSION H(9,9),PAR(44)
      IME=MESH+1
      KK=0
      IIW=0
      DO 20   IY=1,IMESH
      DO 20   IX=1,IY
      DO 20   IZ=1,IX
      IT= IX+IY-1
      IF(IMESH.LT.IT)  GO TO 20
      IW=48
      IF(IZ.EQ.1 ) IW=24
      IF(IX.EQ.IY) IW=24
      IF(IX.EQ.IZ) IW=24
      IF((IX+IY).EQ.(2*IME)) IW=24
      IF((IY+IZ).EQ.(2*IME).AND.IX.EQ.IZ) IW=8
      IF((IX+IY).EQ.(2*IME).AND.IZ.EQ.1) IW=12
      IF(IY.EQ.IZ) IW=8
      IF(IY.EQ.IX.AND.IZ.EQ.1) IW=12
      IF(IX.EQ.1) IW=6
      IF(IY.EQ.1.OR.IY.EQ.IMESH) IW=1
      IF(IX.EQ.IME.AND.IY.EQ.IME) IW=12
      IF(IX.EQ.IME.AND.IY.EQ.IME.AND.IZ.EQ.1) IW=6
      IF(IX.EQ.IME.AND.IY.EQ.IME.AND.IZ.EQ.IME) IW=2
      IF(MESH*3.EQ.IT) GO TO 30
      IF(IY.EQ.IMESH) GO TO 4420
      GO TO 4420
   30 CONTINUE
      IW=IW/2
      IF(IZ.EQ.1) IW=IW*2/3
      IF(IY.EQ.IMESH) IW=IW*2/3
      IF(IY.EQ.IMESH.AND.IZ.EQ.1) IW=6
      GO TO 4420
   40 CONTINUE
      IW=IW/2
 4420 CONTINUE
      W=IW
      KK=KK+1
      WT(KK)=W
   20 CONTINUE
C  20 WRITE(6,3) I,J,K,KK,WT(KK)
    3 FORMAT(1X,4I5,F10.5)
      SWT=0.0
      DO 25 I=1,KK
   25 SWT=SWT+WT(I)
      WRITE(30,4)SWT
C     WRITE(6,4) SWT
    4 FORMAT(' SUM OF WEIGHTS IS',E16.7)
      RETURN
      END
      SUBROUTINE MATS(X1,Y1,Z1,MAXM1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ANUMEL(1000),DUMM(1000),EDUM(1000)
      DIMENSION DUMS1(1000),DUMS2(1000),ANUMS1(1000),ANUMS2(1000)
      COMMON/BLOC1/HMZ,    QQ,WEIGHT,XR,XI,YR,YI,GS,RES,H,PAR,
     1GR,GI,ANUMEL,ANUMS1,ANUMS2,DUMS1,DUMS2,DUMM,EDUM
      DIMENSION XR(50,9,9),XI(50,9,9),YR(50,9,9),YI(50,9,9),GS(30,300)
      DIMENSION HMZ(9,9,300),QQ(300,3),WEIGHT(300),RES(1000,21)
       DIMENSION GR(9,9),GI(9,9)
      DIMENSION H(9,9),PAR(44)
      N=9
      PI=3.14159265
      SR2=SQRT(2.)
      SR3=SQRT(3.)
      A1=PAR(1)
      A5=PAR(2)
      A11=PAR(3)
      A15=PAR(4)
      A2=PAR(5)
      A3=PAR(6)
      A4=PAR(7)
      A6=PAR(8)
      A7=PAR(9)
      A8=PAR(10)
      A9=PAR(11)
      A10=PAR(12)
      A12=PAR(13)
      A13=PAR(14)
      A14=PAR(15)
      A16=PAR(16)
      B1=PAR(17)
      B2=PAR(18)
      B3=PAR(19)
      B4=PAR(20)
      B5=PAR(21)
      B6=PAR(22)
      B7=PAR(23)
      B8=PAR(24)
      B9=PAR(25)
      B10=PAR(26)
      B11=PAR(27)
      C1=PAR(28)
      C2=PAR(29)
      C3=PAR(30)
      C4=PAR(31)
      C5=PAR(32)
      C6=PAR(33)
      C7=PAR(34)
      C8=PAR(35)
      C9=PAR(36)
      C10=PAR(37)
      C11=PAR(38)
      C12=PAR(39)
      C13=PAR(40)
      C14=PAR(41)
      C15=PAR(42)
      C16=PAR(43)
      C17=PAR(44)
      MAX=MAXM1
      DO 9 I=1,MAX
      DO 9 J=1,MAX
  9   H(I,J)=0.0
      X2=PI*X1
      Y2=PI*Y1
      Z2=PI*Z1
      CIX=COS(X2)
      CIY=COS(Y2)
      CIZ=COS(Z2)
      SIX=SIN(X2)
      SIY=SIN(Y2)
      SIZ=SIN(Z2)
      COS2X=COS(2.*X2)
      COS2Y=COS(2.*Y2)
      COS2Z=COS(2.*Z2)
      SIN2X=SIN(2.*X2)
      SIN2Y=SIN(2.*Y2)
      SIN2Z=SIN(2.*Z2)
      H(1,1)=A1+8.*A2*CIX*CIY*CIZ+2.*B1*(COS2X+COS2Y+COS2Z)+4.*C1*(COS2X
     1*COS2Y+COS2Y*COS2Z+COS2Z*COS2X)
      H(1,2)=8.*A3*SIX*CIY*CIZ+2.*B2*SIN2X +4.*C2*SIN2X*(COS2Y+COS2Z)
      H(1,3)=8.*A3*CIX*SIY*CIZ+2.*B2*SIN2Y+4.*C2*SIN2Y*(COS2Z+COS2X)
      H(1,4)=8.*A3*CIX*CIY*SIZ+2.*B2*SIN2Z+4.*C2*SIN2Z*(COS2X+COS2Y)
      H(1,2)=-H(1,2)
      H(1,3)=-H(1,3)
      H(1,4)=-H(1,4)
      H(1,5)=-8.*A4*SIX*SIY*CIZ-4.*C3*SIN2X*SIN2Y
      H(1,6)=-8.*A4*CIX*SIY*SIZ-4.*C3*SIN2Y*SIN2Z
      H(1,7)=-8.*A4*SIX*CIY*SIZ-4.*C3*SIN2Z*SIN2X
      H(1,8)=SR3    *B3*(COS2X-COS2Y)+2.*SR3*C4*COS2Z*(COS2Y-COS2X)
      H(1,9)=B3*(-COS2X-COS2Y+2.*COS2Z)-2.*C4*(-2.*COS2X*COS2Y+COS2X*
     1COS2Z+COS2Y*COS2Z)
      H(2,2)=A5+8.*A6*CIX*CIY*CIZ+2.*B4*COS2X+2.*B5*(COS2Y+COS2Z)
     1+4.*C5*COS2X*(COS2Y+COS2Z)+4.*C6*COS2Y*COS2Z
      H(2,3)=-8.*A7*SIX*SIY*CIZ-4.*C7*SIN2X*SIN2Y
      H(2,4)=-8.*A7*SIX*CIY*SIZ-4.*C7*SIN2X*SIN2Z
      H(2,5)=8.*A8*CIX*SIY*CIZ+2.*B6*SIN2Y+4.*C8*COS2X*SIN2Y+4.*C9*SIN2Y
     1*COS2Z
      H(2,6)=-8.*A9*SIX*SIY*SIZ
      H(2,7)=8.*A8*CIX*CIY*SIZ+2.*B6*SIN2Z+4.*C8*COS2X*SIN2Z+4.*C9*SIN2Z
     1*COS2Y
      H(2,8)=8.*A10*SIX*CIY*CIZ+SR3*B7*SIN2X+2.*SR3*C10*SIN2X*(COS2Y+
     1COS2Z)+2.*C11*SIN2X*(COS2Y-COS2Z)
      H(2,9)=-(8./1.73205)*A10*SIX*CIY*CIZ-B7*SIN2X-2.*C10*SIN2X*(COS2Y+
     1COS2Z)+2.*SR3*C11*SIN2X*(COS2Y-COS2Z)
      H(3,3)=A5+8.*A6*CIX*CIY*CIZ+2.*B4*COS2Y+2.*B5*(COS2Z+COS2X)+
     14.*C5*COS2Y*(COS2Z+COS2X)+4.*C6*COS2Z*COS2X
      H(3,4)=-8.*A7*CIX*SIY*SIZ-4.*C7*SIN2Y*SIN2Z
      H(3,5)=8.*A8*SIX*CIY*CIZ+2.*B6*SIN2X+4.*C8*COS2Y*SIN2X+4.*C9*SIN2X
     1*COS2Z
      H(3,6)=8.*A8*CIX*CIY*SIZ+2.*B6*SIN2Z+4.*C8*COS2Y*SIN2Z+4.*C9*SIN2Z
     1*COS2X
      H(3,7)=-8.*A9*SIX*SIY*SIZ
      H(3,8)=-8.*A10*CIX*SIY*CIZ-1.73205*B7*SIN2Y-2.*SR3*C10*SIN2Y*
     1(COS2Z+COS2X)-2.*C11*SIN2Y*(COS2X-COS2Z)
      H(3,9)=-(8./1.73205)*A10*CIX*SIY*CIZ-B7*SIN2Y-2.*C10*SIN2Y*
     1(COS2Z+COS2X)-2.*SR3*C11*SIN2Y*(COS2Z-COS2X)
      H(4,4)=A5+8.*A6*CIX*CIY*CIZ+2.*B5*(COS2X+COS2Y)+2.*B4*COS2Z
     1+4.*C5*COS2Z*(COS2X+COS2Y)+4.*C6*COS2X*COS2Y
      H(4,5)=-8.*A9*SIX*SIY*SIZ
      H(4,6)=8.*A8*CIX*SIY*CIZ+2.*B6*SIN2Y+4*C8*COS2Z*SIN2Y+4.*C9*SIN2Y
     1*COS2X
      H(4,7)=8.*A8*SIX*CIY*CIZ+2.*B6*SIN2X+4.*C8*COS2Z*SIN2X+4.*C9*SIN2X
     1*COS2Y
      H(4,8)=4.*C11*SIN2Z*(COS2Y-COS2X)
      H(4,9)= (16./1.73205)*A10*CIX*CIY*SIZ+2.*B7*SIN2Z+4*C10*SIN2Z*
     1(COS2X+COS2Y)
      H(5,5)=A11+8.*A12*CIX*CIY*CIZ+2.*B8*(COS2X+COS2Y)+2.*B9*COS2Z
     1+4.*C12*COS2X*COS2Y+4.*C13*COS2Z*(COS2X+COS2Y)
      H(5,6)=-8.*A13*SIX*CIY*SIZ-4.*C14*SIN2X*SIN2Z
      H(5,7)=-8.*A13*CIX*SIY*SIZ-4.*C14*SIN2Y*SIN2Z
      H(5,8)=0.0
      H(5,9)=-8.*A14*SIX*SIY*CIZ-4.*C15*SIN2X*SIN2Y
      H(6,6)=A11+8.*A12*CIX*CIY*CIZ+2.*B8*(COS2Z+COS2Y)+2.*B9*COS2X
     1+4.*C12*COS2Z*COS2Y+4.*C13*COS2X*(COS2Z+COS2Y)
      H(6,7)=-8.*A13*SIX*SIY*CIZ-4.*C14*SIN2Y*SIN2X
      H(6,8)=-4.*1.73205*A14*CIX*SIY*SIZ-2.*SR3*C15*SIN2Y*SIN2Z
      H(6,9)=4.*A14*CIX*SIY*SIZ+2.*C15*SIN2Y*SIN2Z
      H(7,7)=A11+8.*A12*CIX*CIY*CIZ+2.*B8*(COS2Z+COS2X)+2.*B9*COS2Y
     1+4.*C12*COS2Z*COS2X+4.*C13*COS2Y*(COS2X+COS2Z)
      H(7,8)=4.*1.73205*A14*SIX*CIY*SIZ+2.*SR3*C15*SIN2X*SIN2Z
      H(7,9)=4.*A14*SIX*CIY*SIZ+2.*C15*SIN2X*SIN2Z
      H(8,8)=A15+8.*A16*CIX*CIY*CIZ+(3./2.)*B10*(COS2X+COS2Y)+2.*B11*
     +(.25*COS2X+.25*COS2Y+COS2Z)+3.*C16*COS2Z*(COS2X+COS2Y)+C17*(4.*
     1COS2X*COS2Y+COS2X*COS2Z+COS2Y*COS2Z)
      H(8,9)=(1./2.)*1.73205*B10*(-COS2X+COS2Y)-.5*1.73205*B11*(-COS2X+
     +COS2Y)+SR3*(C16-C17)*COS2Z*(COS2X-COS2Y)
      H(9,9)=A15+8.*A16*CIX*CIY*CIZ+2.*B10*(.25*COS2X+.25*COS2Y+COS2Z)+
     1(3./2.)*B11*(COS2X+COS2Y)+C16*(4.*COS2X*COS2Y+COS2X*COS2Z+COS2Y*
     2COS2Z)+3.*C17*COS2Z*(COS2X+COS2Y)
      DO 310 L=1,N
      DO 310 K=1,N
 310  H(K,L)=H(L,K)
      H(1,1)=H(1,1)-A1
      H(2,2)=H(2,2)-A5
      H(3,3)=H(3,3)-A5
      H(4,4)=H(4,4)-A5
      H(5,5)=H(5,5)-A11
      H(6,6)=H(6,6)-A11
      H(7,7)=H(7,7)-A11
      H(8,8)=H(8,8)-A15
      H(9,9)=H(9,9)-A15
      RETURN
      END
